/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.207 by jmc, Wed May 26 00:08:18 2010 UTC revision 1.214 by jmc, Sat Nov 6 19:03:41 2010 UTC
# Line 1  Line 1 
1  #! /usr/bin/env bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4    # $Name$
5  #  #
6  # Makefile generator for MITgcm UV codes  # Makefile generator for MITgcm UV codes
7  #   created  by cnh 03/98  #   created  by cnh 03/98
# Line 8  Line 9 
9  #   modified by aja 01/00  #   modified by aja 01/00
10  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
11    
12    #  Explain usage
13    usage()  {
14    cat <<EOF
15    
16    Usage: "$0" [OPTIONS]
17      where [OPTIONS] can be:
18    
19        -help | --help | -h | --h
20              Print this help message and exit.
21    
22        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
23          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
24              Use "NAME" as the adoptfile.  By default, the file at
25              "tools/adjoint_options/adjoint_default" will be used.
26    
27        -nooptfile | --nooptfile
28          -optfile NAME | --optfile NAME | -of NAME | --of NAME
29          -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
30              Use "NAME" as the optfile.  By default, an attempt will be
31              made to find an appropriate "standard" optfile in the
32              tools/build_options/ directory.
33    
34        -pdepend NAME | --pdepend NAME
35          -pdepend=NAME | --pdepend=NAME
36              Get package dependency information from "NAME".
37    
38        -pgroups NAME | --pgroups NAME
39          -pgroups=NAME | --pgroups=NAME
40              Get the package groups information from "NAME".
41    
42        -bash NAME
43              Explicitly specify the Bourne or BASH shell to use
44    
45        -make NAME | -m NAME
46          --make=NAME | -m=NAME
47              Use "NAME" for the MAKE program. The default is "make" but
48              many platforms, "gmake" is the preferred choice.
49    
50        -makefile NAME | -mf NAME
51          --makefile=NAME | -mf=NAME
52              Call the makefile "NAME".  The default is "Makefile".
53    
54        -makedepend NAME | -md NAME
55          --makedepend=NAME | -md=NAME
56              Use "NAME" for the MAKEDEPEND program.
57    
58        -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
59          -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
60              Specify the location of the MITgcm ROOTDIR as "NAME".
61              By default, genamke will try to find the location by
62              looking in parent directories (up to the 5th parent).
63    
64        -mods NAME | --mods NAME | -mo NAME | --mo NAME
65          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
66              Here, "NAME" specifies a list of directories that are
67              used for additional source code.  Files found in the
68              "mods list" are given preference over files of the same
69              name found elsewhere.
70    
71        -disable NAME | --disable NAME
72          -disable=NAME | --disable=NAME
73              Here "NAME" specifies a list of packages that we don't
74              want to use.  If this violates package dependencies,
75              genamke will exit with an error message.
76    
77        -enable NAME | --enable NAME
78          -enable=NAME | --enable=NAME
79              Here "NAME" specifies a list of packages that we wish
80              to specifically enable.  If this violates package
81              dependencies, genamke will exit with an error message.
82    
83        -standarddirs NAME | --standarddirs NAME
84          -standarddirs=NAME | --standarddirs=NAME
85              Here, "NAME" specifies a list of directories to be
86              used as the "standard" code.
87    
88        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
89          -fc=NAME | --fc=NAME
90              Use "NAME" as the fortran compiler.  By default, genmake
91              will search for a working compiler by trying a list of
92              "usual suspects" such as g77, f77, etc.
93    
94        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
95              Use "NAME" as the C compiler.  By default, genmake
96              will search for a working compiler by trying a list of
97              "usual suspects" such as gcc, c89, cc, etc.
98    
99        -[no]ieee | --[no]ieee
100              Do or don't use IEEE numerics.  Note that this option
101              *only* works if it is supported by the OPTFILE that
102              is being used.
103    
104        -use_real4 | -use_r4 | -ur4 | --use_real4 | --use_r4 | --ur4
105              Use "real*4" type for _RS variable (#undef REAL4_IS_SLOW)
106              *only* works if CPP_EEOPTIONS.h allows this.
107    
108        -ignoretime | -ignore_time | --ignoretime | --ignore_time
109              Ignore all the "wall clock" routines entirely.  This will
110              not in any way hurt the model results -- it simply means
111              that the code that checks how long the model spends in
112              various routines will give junk values.
113    
114        -ts | --ts
115              Produce timing information per timestep
116        -papis | --papis
117              Produce summary MFlop/s (and IPC) with PAPI per timestep
118        -pcls | --pcls
119              Produce summary MFlop/s etc. with PCL per timestep
120        -foolad | --foolad
121              Fool the AD code generator
122        -papi | --papi
123              Performance analysis with PAPI
124        -pcl | --pcl
125              Performance analysis with PCL
126        -hpmt | --hpmt
127              Performance analysis with the HPM Toolkit
128    
129        -gsl | --gsl
130              Use GSL to control floating point rounding and precision
131        -devel | --devel
132              Add additional warning and debugging flags for development
133    
134        -mpi | --mpi
135              Include MPI header files and link to MPI libraries
136        -mpi=PATH | --mpi=PATH
137              Include MPI header files and link to MPI libraries using MPI_ROOT
138              set to PATH. i.e. Include files from \$PATH/include, link to libraries
139              from \$PATH/lib and use binaries from \$PATH/bin.
140    
141        -omp | --omp
142              Activate OpenMP code + use Compiler option OMPFLAG
143        -omp=OMPFLAG | --omp=OMPFLAG
144              Activate OpenMP code + use Compiler option OMPFLAG
145    
146        -es | --es | -embed-source | --embed-source
147              Embed a tarball containing the full source code
148              (including the Makefile, etc.) used to build the
149              executable [off by default]
150    
151        -ds | --ds
152              Report genmake internal variables status (DUMPSTATE)
153              to file "genmake_state" (for debug purpose)
154    
155      While it is most often a single word, the "NAME" variables specified
156      above can in many cases be a space-delimited string such as:
157    
158        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
159        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
160        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
161    
162      which, depending upon your shell, may need to be single-quoted.
163    
164      For more detailed genmake documentation, please see:
165    
166        http://mitgcm.org/public/devel_HOWTO/
167    
168    EOF
169    
170        exit 1
171    }
172    
173  # Search for particular CPP #cmds associated with packages  # Search for particular CPP #cmds associated with packages
174  # usage: test_for_package_in_cpp_options CPP_file package_name  # usage: test_for_package_in_cpp_options CPP_file package_name
175  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
# Line 56  test_for_string_in_file() { Line 218  test_for_string_in_file() {
218  # the package list.  # the package list.
219  expand_pkg_groups() {  expand_pkg_groups() {
220      new_packages=      new_packages=
     PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"  
221      if test -r $PKG_GROUPS ; then      if test -r $PKG_GROUPS ; then
222          cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp          cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
223          cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp          cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
# Line 67  expand_pkg_groups() { Line 228  expand_pkg_groups() {
228              if test "x$RETVAL" = x0 ; then              if test "x$RETVAL" = x0 ; then
229                  matched=1                  matched=1
230                  replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`                  replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
231                  echo "    replacing \"$i\" with: $replace"                  echo "    replacing \"$i\" with:$replace"
232                  new_packages="$new_packages $replace"                  new_packages="$new_packages $replace"
233              else              else
234                  new_packages="$new_packages $i"                  new_packages="$new_packages $i"
# Line 165  EOF Line 326  EOF
326      return      return
327  }  }
328    
   
329  look_for_makedepend()  {  look_for_makedepend()  {
330    
331      #  The "original" makedepend is part of the Imake system that is      #  The "original" makedepend is part of the Imake system that is
# Line 212  EOF Line 372  EOF
372              MAKEDEPEND=makedepend              MAKEDEPEND=makedepend
373          else          else
374              echo "    a system-default makedepend was not found."              echo "    a system-default makedepend was not found."
   
375              #  Try to build the cyrus implementation              #  Try to build the cyrus implementation
376              build_cyrus_makedepend              build_cyrus_makedepend
377              RETVAL=$?              RETVAL=$?
# Line 231  EOF Line 390  EOF
390      fi      fi
391  }  }
392    
   
393  build_cyrus_makedepend()  {  build_cyrus_makedepend()  {
394      rm -f ./genmake_cy_md      rm -f ./genmake_cy_md
395      (      (
# Line 256  build_cyrus_makedepend()  { Line 414  build_cyrus_makedepend()  {
414      fi      fi
415  }  }
416    
   
417  build_embed_encode()  build_embed_encode()
418  {  {
419      printf "  building the embed-encode utility...  "      printf "  building the embed-encode utility...  "
# Line 290  build_embed_encode() Line 447  build_embed_encode()
447      DEFINES="$DEFINES -DHAVE_EMBED_SRC"      DEFINES="$DEFINES -DHAVE_EMBED_SRC"
448  }  }
449    
450    #  look for possible C compilers
451  # Guess possible config options for this host  look_for_C_compilers() {
452  find_possible_configs()  {      echo >> $LOGFILE
453        echo "running: look_for_C_compilers()" >> $LOGFILE
454      tmp1=`uname`"_"`uname -m`      rm -f ./genmake_hello.c  ./genmake_hello
455      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      cat >> genmake_hello.c << EOF
     tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`  
     tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`  
     tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`  
     tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`  
     PLATFORM=$tmp3  
     echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32  
     OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`  
     echo "  The platform appears to be:  $PLATFORM"  
   
     echo "test" > test  
     ln -s ./test link  
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         LN="ln -s"  
     else  
         echo "Error: \"ln -s\" does not appear to work on this system!"  
         echo "  For help, please contact <MITgcm-support@mitgcm.org>."  
         exit 1  
     fi  
     rm -f test link  
   
     if test "x$CPP" = x ; then  
         CPP="cpp -traditional -P"  
     fi  
   
     look_for_makedepend  
   
     #================================================================  
     #  look for possible C compilers  
     tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"  
     p_CC=  
     for c in $tmp ; do  
         rm -f ./genmake_hello.c  ./genmake_hello  
         cat >> genmake_hello.c << EOF  
456  #include <stdio.h>  #include <stdio.h>
457  int main(int argc, char **argv) {  int main(int argc, char **argv) {
458    printf("Hello!\n");    printf("Hello!\n");
459    return 0;    return 0;
460  }  }
461  EOF  EOF
462          $c -o genmake_hello genmake_hello.c > /dev/null 2>&1      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
463        p_CC=
464        for c in $tmp ; do
465            COMM="$c $CFLAGS -o genmake_hello genmake_hello.c"
466            echo $COMM >> $LOGFILE
467            $COMM >> $LOGFILE 2>&1
468          RETVAL=$?          RETVAL=$?
469          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
470                echo " $c test successful" >> $LOGFILE
471              p_CC="$p_CC $c"              p_CC="$p_CC $c"
472          fi          fi
473      done      done
# Line 354  Error: No C compilers were found in your Line 483  Error: No C compilers were found in your
483  EOF  EOF
484          exit 1          exit 1
485      else      else
486          echo "  The possible C compilers found in your path are:"          echo "  The possible C compilers found in your path are: $p_CC" | tee -a $LOGFILE
         echo "   "$p_CC  
487          if test "x$CC" = x ; then          if test "x$CC" = x ; then
488              CC=`echo $p_CC | $AWK '{print $1}'`              CC=`echo $p_CC | $AWK '{print $1}'`
489              echo "  Setting C compiler to: "$CC              echo "  Setting C compiler to: "$CC
490          fi          fi
491      fi      fi
492        echo " --> set CC='$CC'" >> $LOGFILE
493    }
494    
495    # Guess possible config options for this host
496    find_possible_optfile()  {
497    
498        echo >> $LOGFILE
499        echo "running: find_possible_optfile()" >> $LOGFILE
500        tmp1=`uname`"_"`uname -m`
501        tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
502        tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
503        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
504        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
505        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
506        PLATFORM=$tmp3
507        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
508        OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
509        echo "  The platform appears to be:  $PLATFORM" | tee -a $LOGFILE
510    
511      #================================================================      #================================================================
512      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
513      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"      echo "  look for possible FORTRAN compilers" >> $LOGFILE
514        tmp="$MITGCM_FC $FC efc gfortran g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 g95"
515      p_FC=      p_FC=
516      for c in $tmp ; do      rm -f ./genmake_hello.f
517          rm -f ./hello.f ./hello      cat >> genmake_hello.f <<EOF
         cat >> hello.f <<EOF  
518        program hello        program hello
519        do i=1,3        do i=1,3
520          print *, 'hello world : ', i          print *, 'hello world : ', i
521        enddo        enddo
522        end        end
523  EOF  EOF
524          $c -o hello hello.f > /dev/null 2>&1      for f in $tmp ; do
525            COMM="$f -o genmake_hello genmake_hello.f"
526            echo $COMM >> $LOGFILE
527            $COMM >> $LOGFILE 2>&1
528          RETVAL=$?          RETVAL=$?
529          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
530              p_FC="$p_FC $c"              echo " $f test successful" >> $LOGFILE
531                p_FC="$p_FC $f"
532          fi          fi
533      done      done
534      rm -f ./hello.f ./hello      rm -f ./genmake_hello.f ./genmake_hello
535      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
536          cat 1>&2 <<EOF          cat 1>&2 <<EOF
537    
# Line 394  Error: No Fortran compilers were found i Line 544  Error: No Fortran compilers were found i
544  EOF  EOF
545          exit 1          exit 1
546      else      else
547          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are: $p_FC" | tee -a $LOGFILE
         echo "   "$p_FC  
548      fi      fi
549    
550      #  Use the first of the compilers found in the current PATH      #  Use the first of the compilers found in the current PATH
# Line 404  EOF Line 553  EOF
553          for i in $p_FC ; do          for i in $p_FC ; do
554              OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i              OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
555              if test -r $OPTFILE ; then              if test -r $OPTFILE ; then
556                  echo "  Setting OPTFILE to: "$OPTFILE                  echo "  Setting OPTFILE to: "$OPTFILE | tee -a $LOGFILE
557                  break                  break
558              fi              fi
559          done          done
# Line 416  EOF Line 565  EOF
565               echo "  I looked for the file "$OPTFILE" but did not find it"               echo "  I looked for the file "$OPTFILE" but did not find it"
566          fi          fi
567      fi      fi
568  #    echo "  The options file:  $p_OF"  
 #    echo "    appears to match so we'll use it."  
 #   for i in $p_FC ; do  
 #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i  
 #if test -r $p_OF ; then  
 #    OPTFILE=$p_OF  
 #    echo "  The options file:  $p_OF"  
 #    echo "    appears to match so we'll use it."  
 #    break  
 #fi  
 #   done  
569      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
570          cat 1>&2 <<EOF          cat 1>&2 <<EOF
571    
# Line 471  EOF Line 610  EOF
610  #       fi  #       fi
611  #       rm -f test.f out  #       rm -f test.f out
612  #     fi  #     fi
   
613  }  }
614    
615  #  Parse the package dependency information  #  Parse the package dependency information
# Line 484  get_pdepend_list()  { Line 622  get_pdepend_list()  {
622          > ./.pd_tmp          > ./.pd_tmp
623      RETVAL=$?      RETVAL=$?
624      if test ! "x${RETVAL}" = x0 ; then      if test ! "x${RETVAL}" = x0 ; then
625        echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$1\""        echo "Error: unable to parse package dependencies -- please check PKG_DEPEND=\"$1\""
626        exit 1        exit 1
627      fi      fi
628      . ./.pd_tmp      . ./.pd_tmp
629      rm -f ./.pd_tmp      rm -f ./.pd_tmp
   
 }  
   
   
 #  Explain usage  
 usage()  {  
 cat <<EOF  
   
 Usage: "$0" [OPTIONS]  
   where [OPTIONS] can be:  
   
     -help | --help | -h | --h  
           Print this help message and exit.  
   
     -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME  
       -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME  
           Use "NAME" as the adoptfile.  By default, the file at  
           "tools/adjoint_options/adjoint_default" will be used.  
   
     -nooptfile | --nooptfile  
       -optfile NAME | --optfile NAME | -of NAME | --of NAME  
       -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME  
           Use "NAME" as the optfile.  By default, an attempt will be  
           made to find an appropriate "standard" optfile in the  
           tools/build_options/ directory.  
   
     -pdepend NAME | --pdepend NAME  
       -pdepend=NAME | --pdepend=NAME  
           Get package dependency information from "NAME".  
   
     -pdefault NAME | --pdefault NAME  
       -pdefault=NAME | --pdefault=NAME  
           Get the default package list from "NAME".  
   
     -bash NAME  
           Explicitly specify the Bourne or BASH shell to use  
   
     -make NAME | -m NAME  
       --make=NAME | -m=NAME  
           Use "NAME" for the MAKE program. The default is "make" but  
           many platforms, "gmake" is the preferred choice.  
   
     -makefile NAME | -mf NAME  
       --makefile=NAME | -mf=NAME  
           Call the makefile "NAME".  The default is "Makefile".  
   
     -makedepend NAME | -md NAME  
       --makedepend=NAME | -md=NAME  
           Use "NAME" for the MAKEDEPEND program.  
   
     -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME  
       -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME  
           Specify the location of the MITgcm ROOTDIR as "NAME".  
           By default, genamke will try to find the location by  
           looking in parent directories (up to the 5th parent).  
   
     -mods NAME | --mods NAME | -mo NAME | --mo NAME  
       -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME  
           Here, "NAME" specifies a list of directories that are  
           used for additional source code.  Files found in the  
           "mods list" are given preference over files of the same  
           name found elsewhere.  
   
     -disable NAME | --disable NAME  
       -disable=NAME | --disable=NAME  
           Here "NAME" specifies a list of packages that we don't  
           want to use.  If this violates package dependencies,  
           genamke will exit with an error message.  
   
     -enable NAME | --enable NAME  
       -enable=NAME | --enable=NAME  
           Here "NAME" specifies a list of packages that we wish  
           to specifically enable.  If this violates package  
           dependencies, genamke will exit with an error message.  
   
     -standarddirs NAME | --standarddirs NAME  
       -standarddirs=NAME | --standarddirs=NAME  
           Here, "NAME" specifies a list of directories to be  
           used as the "standard" code.  
   
     -fortran NAME | --fortran NAME | -fc NAME | --fc NAME  
       -fc=NAME | --fc=NAME  
           Use "NAME" as the fortran compiler.  By default, genmake  
           will search for a working compiler by trying a list of  
           "usual suspects" such as g77, f77, etc.  
   
     -cc NAME | --cc NAME | -cc=NAME | --cc=NAME  
           Use "NAME" as the C compiler.  By default, genmake  
           will search for a working compiler by trying a list of  
           "usual suspects" such as gcc, c89, cc, etc.  
   
     -[no]ieee | --[no]ieee  
           Do or don't use IEEE numerics.  Note that this option  
           *only* works if it is supported by the OPTFILE that  
           is being used.  
   
     -use_real4 | -use_r4 | -ur4 | --use_real4 | --use_r4 | --ur4  
           Use "real*4" type for _RS variable (#undef REAL4_IS_SLOW)  
           *only* works if CPP_EEOPTIONS.h allows this.  
   
     -ignoretime | -ignore_time | --ignoretime | --ignore_time  
           Ignore all the "wall clock" routines entirely.  This will  
           not in any way hurt the model results -- it simply means  
           that the code that checks how long the model spends in  
           various routines will give junk values.  
   
     -ts | --ts  
           Produce timing information per timestep  
     -papis | --papis  
           Produce summary MFlop/s (and IPC) with PAPI per timestep  
     -pcls | --pcls  
           Produce summary MFlop/s etc. with PCL per timestep  
     -foolad | --foolad  
           Fool the AD code generator  
     -papi | --papi  
           Performance analysis with PAPI  
     -pcl | --pcl  
           Performance analysis with PCL  
     -hpmt | --hpmt  
           Performance analysis with the HPM Toolkit  
   
     -gsl | --gsl  
           Use GSL to control floating point rounding and precision  
     -devel | --devel  
           Add additional warning and debugging flags for development  
   
     -mpi | --mpi  
           Include MPI header files and link to MPI libraries  
     -mpi=PATH | --mpi=PATH  
           Include MPI header files and link to MPI libraries using MPI_ROOT  
           set to PATH. i.e. Include files from \$PATH/include, link to libraries  
           from \$PATH/lib and use binaries from \$PATH/bin.  
   
     -omp | --omp  
           Activate OpenMP code + use Compiler option OMPFLAG  
     -omp=OMPFLAG | --omp=OMPFLAG  
           Activate OpenMP code + use Compiler option OMPFLAG  
   
     -es | --es | -embed-source | --embed-source  
           Embed a tarball containing the full source code  
           (including the Makefile, etc.) used to build the  
           executable [off by default]  
   
   While it is most often a single word, the "NAME" variables specified  
   above can in many cases be a space-delimited string such as:  
   
     --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'  
     -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'  
     -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'  
   
   which, depending upon your shell, may need to be single-quoted.  
   
   For more detailed genmake documentation, please see:  
   
     http://mitgcm.org/public/devel_HOWTO/  
   
 EOF  
   
     exit 1  
630  }  }
631    
632  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
# Line 657  get_fortran_c_namemangling()  { Line 636  get_fortran_c_namemangling()  {
636      if test ! "x$FC_NAMEMANGLE" = x ; then      if test ! "x$FC_NAMEMANGLE" = x ; then
637          return 0          return 0
638      fi      fi
639        echo " running: get_fortran_c_namemangling()" >> $LOGFILE
640    
641      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
642    
643      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
644  void tcall( char * string ) { tsub( string ); }  void tcall( char * string ) { tsub( string ); }
645  EOF  EOF
646      $MAKE genmake_test.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_test.c"
647        echo ' '$COMM >> $LOGFILE
648        $COMM >> $LOGFILE 2>&1
649      RETVAL=$?      RETVAL=$?
650      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
651          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
652          cat <<EOF>> genmake_errors          cat <<EOF>> $LOGFILE
653    
654  WARNING: C test compile fails   WARNING: C test compile fails
655  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'   WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
656  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here   WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
657  EOF  EOF
658          return 1          return 1
659      fi      fi
# Line 679  EOF Line 661  EOF
661      RETVAL=$?      RETVAL=$?
662      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
663          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
664          cat <<EOF>> genmake_warnings          cat <<EOF>> $LOGFILE
665    
666  WARNING: The "nm" command failed.   WARNING: The "nm" command failed.
667  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'   WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
668  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here   WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
669  EOF  EOF
670          return 1          return 1
671      fi      fi
# Line 693  EOF Line 675  EOF
675        call tsub( string )        call tsub( string )
676        end        end
677  EOF  EOF
678      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -c genmake_tcomp.$FS"
679        echo ' '$COMM >> $LOGFILE
680        $COMM >> $LOGFILE 2>&1
681      RETVAL=$?      RETVAL=$?
682      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
683          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
684          cat <<EOF>> genmake_warnings          cat <<EOF>> $LOGFILE
685    
686  WARNING: FORTRAN test compile fails -- please see "genmake_errors"   WARNING: FORTRAN test compile fails -- please see '$LOGFILE'
687  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'   WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
688  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.   WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
689  EOF  EOF
690          return 1          return 1
691      fi      fi
# Line 709  EOF Line 693  EOF
693      RETVAL=$?      RETVAL=$?
694      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
695          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
696          cat <<EOF>> genmake_warnings          cat <<EOF>> $LOGFILE
697    
698  WARNING: The "nm" command failed.   WARNING: The "nm" command failed.
699  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'   WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
700  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.   WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
701  EOF  EOF
702          return 1          return 1
703      fi      fi
# Line 739  EOF Line 723  EOF
723    
724      #  cleanup the testing files      #  cleanup the testing files
725      rm -f genmake_tcomp.* genmake_test.*      rm -f genmake_tcomp.* genmake_test.*
 }  
726    
727        echo " --> set FC_NAMEMANGLE='$FC_NAMEMANGLE'" >> $LOGFILE
728    }
729    
730  check_HAVE_CLOC()  {  check_HAVE_CLOC()  {
731        echo >> $LOGFILE
732        echo "running: check_HAVE_CLOC()" >> $LOGFILE
733      get_fortran_c_namemangling      get_fortran_c_namemangling
734      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
735  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 760  void FC_NAMEMANGLE(cloc) ( double *curti Line 747  void FC_NAMEMANGLE(cloc) ( double *curti
747  }  }
748  EOF  EOF
749      COMM="$CC $CFLAGS -c genmake_tc_1.c"      COMM="$CC $CFLAGS -c genmake_tc_1.c"
750      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
751      $COMM >> genmake_warnings 2>&1      $COMM >> $LOGFILE 2>&1
752      RET_C=$?      RET_C=$?
753      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
754        program hello        program hello
# Line 772  EOF Line 759  EOF
759        end        end
760  EOF  EOF
761      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
762      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
763      $COMM >> genmake_warnings 2>&1      $COMM >> $LOGFILE 2>&1
764      RET_F=$?      RET_F=$?
765      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> $LOGFILE 2>&1
766      RETVAL=$?      RETVAL=$?
767      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
768          HAVE_CLOC=t          HAVE_CLOC=t
769          DEFINES="$DEFINES -DHAVE_CLOC"          DEFINES="$DEFINES -DHAVE_CLOC"
770      fi      fi
771      rm -f genmake_tc*      rm -f genmake_tc*
772        echo " --> set HAVE_CLOC='$HAVE_CLOC'" >> $LOGFILE
773  }  }
774    
   
775  check_HAVE_SIGREG()  {  check_HAVE_SIGREG()  {
776      if test ! "x$HAVE_SIGREG" = x ; then      if test ! "x$HAVE_SIGREG" = x ; then
777          return          return
778      fi      fi
779        echo >> $LOGFILE
780        echo "running: check_HAVE_SIGREG()" >> $LOGFILE
781      get_fortran_c_namemangling      get_fortran_c_namemangling
782      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
783  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 821  void FC_NAMEMANGLE(sigreg) (int * aip) Line 810  void FC_NAMEMANGLE(sigreg) (int * aip)
810  }  }
811  EOF  EOF
812      COMM="$CC $CFLAGS -c genmake_tc_1.c"      COMM="$CC $CFLAGS -c genmake_tc_1.c"
813      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
814      $COMM >> genmake_warnings 2>&1      $COMM >> $LOGFILE 2>&1
815      RET_C=$?      RET_C=$?
816      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
817        program hello        program hello
# Line 832  EOF Line 821  EOF
821        call sigreg(anint)        call sigreg(anint)
822        end        end
823  EOF  EOF
824      echo >> genmake_warnings      cat genmake_tc_2.$FS >> $LOGFILE
     echo "running: check_HAVE_SIGREG()" >> genmake_warnings  
     cat genmake_tc_2.$FS >> genmake_warnings  
825      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
826      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
827      $COMM >> genmake_warnings 2>&1      $COMM >> $LOGFILE 2>&1
828      RETVAL=$?      RETVAL=$?
829      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
830          HAVE_SIGREG=t          HAVE_SIGREG=t
831          DEFINES="$DEFINES -DHAVE_SIGREG"          DEFINES="$DEFINES -DHAVE_SIGREG"
832      fi      fi
833      rm -f genmake_tc*      rm -f genmake_tc*
834        echo " --> set HAVE_SIGREG='$HAVE_SIGREG'" >> $LOGFILE
835  }  }
836    
   
837  check_HAVE_SETRLSTK()  {  check_HAVE_SETRLSTK()  {
838      if test "x$HAVE_SETRLSTK" = xt ; then      if test "x$HAVE_SETRLSTK" = xt ; then
839          DEFINES="$DEFINES -DHAVE_SETRLSTK"          DEFINES="$DEFINES -DHAVE_SETRLSTK"
# Line 855  check_HAVE_SETRLSTK()  { Line 842  check_HAVE_SETRLSTK()  {
842      if test ! "x$HAVE_SETRLSTK" = x ; then      if test ! "x$HAVE_SETRLSTK" = x ; then
843          return          return
844      fi      fi
845        echo >> $LOGFILE
846        echo "running: check_HAVE_SETRLSTK()" >> $LOGFILE
847      get_fortran_c_namemangling      get_fortran_c_namemangling
848      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
849  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 871  void FC_NAMEMANGLE(setrlstk) () Line 860  void FC_NAMEMANGLE(setrlstk) ()
860  }  }
861  EOF  EOF
862      COMM="$CC $CFLAGS -c genmake_tc_1.c"      COMM="$CC $CFLAGS -c genmake_tc_1.c"
863      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
864      $COMM >> genmake_warnings 2>&1      $COMM >> $LOGFILE 2>&1
865      RET_C=$?      RET_C=$?
866      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
867        program hello        program hello
# Line 880  EOF Line 869  EOF
869        call setrlstk()        call setrlstk()
870        end        end
871  EOF  EOF
872      echo >> genmake_warnings      cat genmake_tc_2.$FS >> $LOGFILE
     echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings  
     cat genmake_tc_2.$FS >> genmake_warnings  
873      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
874      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
875      $COMM >> genmake_warnings 2>&1      $COMM >> $LOGFILE 2>&1
876      RETVAL=$?      RETVAL=$?
877      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
878          HAVE_SETRLSTK=t          HAVE_SETRLSTK=t
879          DEFINES="$DEFINES -DHAVE_SETRLSTK"          DEFINES="$DEFINES -DHAVE_SETRLSTK"
880      fi      fi
881      rm -f genmake_tc*      rm -f genmake_tc*
882        echo " --> set HAVE_SETRLSTK='$HAVE_SETRLSTK'" >> $LOGFILE
883  }  }
884    
   
885  check_HAVE_STAT()  {  check_HAVE_STAT()  {
886        echo >> $LOGFILE
887        echo "running: check_HAVE_STAT()" >> $LOGFILE
888      get_fortran_c_namemangling      get_fortran_c_namemangling
889      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
890  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 917  void FC_NAMEMANGLE(tfsize) ( int *nbyte Line 906  void FC_NAMEMANGLE(tfsize) ( int *nbyte
906  }  }
907  EOF  EOF
908      COMM="$CC $CFLAGS -c genmake_tc_1.c"      COMM="$CC $CFLAGS -c genmake_tc_1.c"
909      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
910      $COMM >> genmake_tc.log 2>&1      $COMM >> genmake_tc.log 2>&1
911      RET_C=$?      RET_C=$?
912      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
# Line 927  EOF Line 916  EOF
916        print *," HELLO WORLD", nbyte        print *," HELLO WORLD", nbyte
917        end        end
918  EOF  EOF
919      echo >> genmake_warnings      cat genmake_tc_2.$FS >> $LOGFILE
     echo "running: check_HAVE_STAT()" >> genmake_warnings  
     cat genmake_tc_2.$FS >> genmake_warnings  
920      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
921      echo $COMM >> genmake_warnings      echo $COMM >> $LOGFILE
922      $COMM >> genmake_tc.log 2>&1      $COMM >> genmake_tc.log 2>&1
923      RETVAL=$?      RETVAL=$?
924      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
# Line 939  EOF Line 926  EOF
926          DEFINES="$DEFINES -DHAVE_STAT"          DEFINES="$DEFINES -DHAVE_STAT"
927      fi      fi
928      rm -f genmake_tc*      rm -f genmake_tc*
929        echo " --> set HAVE_STAT='$HAVE_STAT'" >> $LOGFILE
930  }  }
931    
   
932  check_netcdf_libs()  {  check_netcdf_libs()  {
933      if test ! "x$SKIP_NETCDF_CHECK" = x ; then      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
934          return          return
935      fi      fi
936      echo >> genmake_warnings      echo >> $LOGFILE
937      echo "running: check_netcdf_libs()" >> genmake_warnings      echo "running: check_netcdf_libs()" >> $LOGFILE
938      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.F
939        program fgennc        program fgennc
940  #include "netcdf.inc"  #include "netcdf.inc"
# Line 965  EOF Line 952  EOF
952        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
953        end        end
954  EOF  EOF
955      echo "===  genmake_tnc.F  ===" > genmake_tnc.log      echo "===  genmake_tnc.F  >>>" > genmake_tnc.log
956      cat genmake_tnc.F >> genmake_tnc.log      cat genmake_tnc.F >> genmake_tnc.log
957      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log      echo "<<<  genmake_tnc.F  ===" >> genmake_tnc.log
958      RET_CPP=f      RET_CPP=f
959      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
960      echo "$COMM" >> genmake_tnc.log      echo "$COMM" >> genmake_tnc.log
# Line 983  EOF Line 970  EOF
970      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
971          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
972      RET_COMPILE=$?      RET_COMPILE=$?
973      cat genmake_tnc.log >> genmake_warnings      cat genmake_tnc.log >> $LOGFILE
974    
975      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
976      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 994  EOF Line 981  EOF
981    
982      if test "x$RET_COMPILE" = x0 ; then      if test "x$RET_COMPILE" = x0 ; then
983          HAVE_NETCDF=t          HAVE_NETCDF=t
984            echo "check_netcdf: successful" >> $LOGFILE
985      else      else
986          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
987          echo "try again with added '-lnetcdf'" > genmake_tnc.log          echo "==> try again with added '-lnetcdf'" > genmake_tnc.log
988          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
989          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
990          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
# Line 1004  EOF Line 992  EOF
992              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
993              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
994          RET_COMPILE=$?          RET_COMPILE=$?
995          cat genmake_tnc.log >> genmake_warnings          echo >> $LOGFILE
996            cat genmake_tnc.log >> $LOGFILE
997          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
998              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
999              HAVE_NETCDF=t              HAVE_NETCDF=t
1000                echo "check_netcdf: successful" >> $LOGFILE
1001          else          else
1002          # try again with "-lnetcdff" added to the libs          # try again with "-lnetcdff" added to the libs
1003              echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log              echo "==> try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
1004              echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log              echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
1005              echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log              echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
1006              echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log              echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
# Line 1018  EOF Line 1008  EOF
1008                  &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \                  &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
1009                  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1                  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
1010              RET_COMPILE=$?              RET_COMPILE=$?
1011              cat genmake_tnc.log >> genmake_warnings              echo >> $LOGFILE
1012                cat genmake_tnc.log >> $LOGFILE
1013              if test "x$RET_COMPILE" = x0 ; then              if test "x$RET_COMPILE" = x0 ; then
1014                  LIBS="$LIBS -lnetcdff -lnetcdf"                  LIBS="$LIBS -lnetcdff -lnetcdf"
1015                  HAVE_NETCDF=t                  HAVE_NETCDF=t
1016                    echo "check_netcdf: successful" >> $LOGFILE
1017              fi              fi
1018          fi          fi
1019      fi      fi
1020      rm -f genmake_tnc*      rm -f genmake_tnc*
1021        echo " --> set HAVE_NETCDF='$HAVE_NETCDF'" >> $LOGFILE
1022  }  }
1023    
1024    
   
1025  ###############################################################################  ###############################################################################
1026  #   Sequential part of script starts here  #   Sequential part of script starts here
1027  ###############################################################################  ###############################################################################
# Line 1051  ENABLE= Line 1043  ENABLE=
1043  DISABLE=  DISABLE=
1044  # MAKEFILE=  # MAKEFILE=
1045  # MAKEDEPEND=  # MAKEDEPEND=
1046  PDEPEND=  PKG_DEPEND=
1047  DUMPSTATE=t  PKG_GROUPS=
1048  PDEFAULT=  DUMPSTATE=f
1049  OPTFILE=  OPTFILE=
1050  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1051  FFLAGS=  FFLAGS=
# Line 1138  FTL_TAF_FLAGS= Line 1130  FTL_TAF_FLAGS=
1130  SVD_TAMC_FLAGS=  SVD_TAMC_FLAGS=
1131  TAMC_EXTRA=  TAMC_EXTRA=
1132    
   
1133  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1134  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PKG_DEPEND PKG_GROUPS MAKEFILE MAKEDEPEND PLATFORM ROOTDIR MODS DISABLE ENABLE"
1135  gm_s2="FC IEEE USE_R4 TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI OMP DUMPSTATE STANDARDDIRS"  gm_s2="FC CC IEEE USE_R4 TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI OMP DUMPSTATE STANDARDDIRS"
1136    
1137  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1138  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"  gm_s3="LN S64 LINK MAKE PACKAGES INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1139  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS LIBS KPP KFLAGS1 KFLAGS2 KPPFILES NOOPTFILES NOOPTFLAGS"
1140  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD THISHOST THISUSER THISDATE THISVER MACHINE"
1141  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1142  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"  gm_s7="FC_NAMEMANGLE HAVE_NETCDF HAVE_SYSTEM HAVE_FDATE HAVE_ETIME"
1143    
1144  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
1145  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 1162  cat <<EOF Line 1153  cat <<EOF
1153    
1154  GENMAKE :  GENMAKE :
1155    
1156  A program for GENerating MAKEfiles for the MITgcm project.  For a  A program for GENerating MAKEfiles for the MITgcm project.
1157  quick list of options, use "genmake -h" or for more detail see:     For a quick list of options, use "genmake2 -h"
1158    or for more detail see the Developer's HOWTO manual at:
1159    http://mitgcm.org/devel_HOWTO/     http://mitgcm.org/public/docs.html
1160    
1161  EOF  EOF
1162    
1163    LOGFILE="genmake.log"
1164    #- clean-up previous genmake logfiles:
1165    rm -f genmake_state genmake_*optfile $LOGFILE
1166    
1167  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
1168  gm_local="genmake_local"  gm_local="genmake_local"
1169  printf "  getting local config information:  "  printf "  getting local config information:  "
# Line 1215  for ac_option in "$@" ; do Line 1210  for ac_option in "$@" ; do
1210              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
1211                    
1212          -pdepend | --pdepend)          -pdepend | --pdepend)
1213              ac_prev=PDEPEND ;;              ac_prev=PKG_DEPEND ;;
1214          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
1215              PDEPEND=$ac_optarg ;;              PKG_DEPEND=$ac_optarg ;;
1216                    
1217          -pdefault | --pdefault)          -pgroups | --pgroups)
1218              ac_prev=PDEFAULT ;;              ac_prev=PKG_GROUPS ;;
1219          -pdefault=* | --pdefault=*)          -pgroups=* | --pgroups=*)
1220              PDEFAULT=$ac_optarg ;;              PKG_GROUPS=$ac_optarg ;;
1221                    
1222          -make | --make | -m | --m)          -make | --make | -m | --m)
1223              ac_prev=MAKE ;;              ac_prev=MAKE ;;
# Line 1375  for ac_option in "$@" ; do Line 1370  for ac_option in "$@" ; do
1370    
1371  done  done
1372    
   
1373  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1374      echo      echo
1375      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
# Line 1434  if test "x${OPTFILE}" = x ; then Line 1428  if test "x${OPTFILE}" = x ; then
1428      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
1429          echo "Warning: no OPTFILE specified so we'll look for possible settings"          echo "Warning: no OPTFILE specified so we'll look for possible settings"
1430          printf "\n===  Searching for possible settings for OPTFILE  ===\n"          printf "\n===  Searching for possible settings for OPTFILE  ===\n"
1431          find_possible_configs          find_possible_optfile
1432      else      else
1433          OPTFILE=$MITGCM_OF          OPTFILE=$MITGCM_OF
1434      fi      fi
# Line 1449  if test "x$OPTFILE" != xNONE ; then Line 1443  if test "x$OPTFILE" != xNONE ; then
1443              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1444              exit 1              exit 1
1445          fi          fi
1446          if test "x$DUMPSTATE" != xf ; then          if test "x$DUMPSTATE" = xt ; then
1447              cp -f $OPTFILE "genmake_optfile"              cp -f $OPTFILE "genmake_optfile"
1448          fi          fi
1449      else      else
# Line 1476  if test "x${AD_OPTFILE}" != xNONE ; then Line 1470  if test "x${AD_OPTFILE}" != xNONE ; then
1470              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1471              exit 1              exit 1
1472          fi          fi
1473          if test "x$DUMPSTATE" != xf ; then          if test "x$DUMPSTATE" = xt ; then
1474              cp -f $AD_OPTFILE "genmake_ad_optfile"              cp -f $AD_OPTFILE "genmake_ad_optfile"
1475          fi          fi
1476      else      else
# Line 1504  Error: no Fortran compiler: please speci Line 1498  Error: no Fortran compiler: please speci
1498  EOF  EOF
1499      exit 1      exit 1
1500  fi  fi
1501    
1502  if test "x$CC" = x ; then  if test "x$CC" = x ; then
1503      CC=cc      look_for_C_compilers
 #     cat <<EOF 1>&2  
 # Error: no C compiler: please specify using one of the following:  
 #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"  
 #   2) the "-cc=XXX" command-line option  
 #   3) the "./genmake_local" file  
 # EOF  
 #     exit 1  
1504  fi  fi
1505    
1506  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1507      LINK=$FC      LINK=$FC
1508  fi  fi
# Line 1521  if test "x$MAKE" = x ; then Line 1510  if test "x$MAKE" = x ; then
1510      MAKE="make"      MAKE="make"
1511  fi  fi
1512  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
1513      CPP=cpp      CPP="cpp -traditional -P"
1514  fi  fi
1515  #EH3 === UGLY ===  #EH3 === UGLY ===
1516  #  The following is an ugly little hack to check for $CPP in /lib/ and  #  The following is an ugly little hack to check for $CPP in /lib/ and
# Line 1548  EOF Line 1537  EOF
1537  else  else
1538      rm -f test_cpp      rm -f test_cpp
1539  fi  fi
1540    
1541  look_for_makedepend  look_for_makedepend
1542    
1543    #  Check that soft-link command is set and usable
1544  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1545      LN="ln -s"      LN="ln -s"
1546  fi  fi
# Line 1558  RETVAL=$? Line 1550  RETVAL=$?
1550  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
1551      cat <<EOF 1>&2      cat <<EOF 1>&2
1552    
1553  Error: The command "ln -s" failed -- please specify a working soft-link  Error: The command "$LN" failed -- please specify a working soft-link
1554    command in the optfile.    command in the optfile.
1555    
1556  EOF  EOF
# Line 1795  if test "x$EMBED_SRC" = xt ; then Line 1787  if test "x$EMBED_SRC" = xt ; then
1787      ENABLE="$ENABLE embed_files"      ENABLE="$ENABLE embed_files"
1788  fi  fi
1789    
   
1790  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1791  printf "  Adding MODS directories: "  printf "  Adding MODS directories: "
1792  for d in $MODS ; do  for d in $MODS ; do
# Line 1811  for d in $MODS ; do Line 1802  for d in $MODS ; do
1802  done  done
1803  echo  echo
1804    
1805  if test "x${PLATFORM}" = x ; then  #if test "x${PLATFORM}" = x ; then
1806      PLATFORM=$p_PLATFORM  #    PLATFORM=$p_PLATFORM
1807  fi  #fi
1808    
1809  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1810      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
# Line 1913  for pdir in exch2 regrid ; do Line 1904  for pdir in exch2 regrid ; do
1904  done  done
1905    
1906  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1907  if  test "x${PDEPEND}" = x ; then  if  test "x${PKG_DEPEND}" = x ; then
1908      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
1909      if test -r $tmp ; then      if test -r $tmp ; then PKG_DEPEND=$tmp ; fi
1910          PDEPEND=$tmp  fi
1911      else  if  test "x${PKG_DEPEND}" = x ; then
1912          echo "Warning:  No package dependency information was specified."          echo "Warning:  No package dependency information was specified."
1913          echo "  Please check that ROOTDIR/pkg/pkg_depend exists."          echo "  Please check that ROOTDIR/pkg/pkg_depend exists."
1914    else
1915        if test ! -r ${PKG_DEPEND} ; then
1916            echo "Error:  can't read package dependency info from PKG_DEPEND=\"$PKG_DEPEND\""
1917            exit 1
1918      fi      fi
1919        echo "  getting package dependency info from  $PKG_DEPEND"
1920    #  Strip the comments and then convert the dependency file into arrays: PNAME, DNAME
1921        get_pdepend_list $PKG_DEPEND
1922    fi
1923    
1924    # A default package groups file "$ROOTDIR/pkg/pkg_groups" is provided
1925    #  to define the "default_pkg_list" and package groups (for convenience, one
1926    #  can specify a group of packages using names like "ocean" and "atmosphere").
1927    if test "x${PKG_GROUPS}" = x ; then
1928        tmp=$ROOTDIR"/pkg/pkg_groups"
1929        if test -r $tmp ; then PKG_GROUPS=$tmp ; fi
1930    fi
1931    if test "x${PKG_GROUPS}" = x ; then
1932            echo "Warning:  No package groups information was specified."
1933            echo "  Please check that ROOTDIR/pkg/pkg_groups exists."
1934  else  else
1935      if test ! -r ${PDEPEND} ; then      if test ! -r ${PKG_GROUPS} ; then
1936          echo "Error:  can't read package dependency info from PDEPEND=\"$PDEPEND\""          echo "Error:  can't read package groups info from PKG_GROUPS=\"$PKG_GROUPS\""
1937          exit 1          exit 1
1938      fi      fi
1939        echo "  getting package groups info from      $PKG_GROUPS"
1940  fi  fi
1941  echo "  getting package dependency info from  $PDEPEND"  
1942  #  Strip the comments and then convert the dependency file into  #  Search for packages to compile.
1943  #  two arrays: PNAME, DNAME  echo "  checking list of packages to compile:"
1944  get_pdepend_list $PDEPEND  PKG_LIST=
1945    if test "x${PKG_LIST}" = x ; then
 #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  
 #  file has been added so that, for convenience, one can specify  
 #  groups of packages using names like "ocean" and "atmosphere".  
 echo "  checking default package list:  "  
 if test "x${PDEFAULT}" = x ; then  
1946      for i in "." $MODS ; do      for i in "." $MODS ; do
1947          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
1948                  PDEFAULT=$i"/packages.conf"                  PKG_LIST=$i"/packages.conf"
1949                  break                  break
1950          fi          fi
1951      done      done
1952  fi  fi
1953  if test "x${PDEFAULT}" = x ; then  if test "x${PKG_LIST}" = x ; then
1954      PDEFAULT="$ROOTDIR/pkg/pkg_default"      pkg_list='default_pkg_list'
1955  fi      if test "x${PKG_GROUPS}" = x ; then
1956  if test "x${PDEFAULT}" = xNONE ; then          echo "Error:  need package groups info to expand pkg_list=\"$pkg_list\""
1957      echo "    default packages file disabled"          exit 1
1958        fi
1959  else  else
1960      if test ! -r $PDEFAULT ; then      if test ! -r $PKG_LIST ; then
1961          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Error:  can't read package list from PKG_LIST=\"$PKG_LIST\""
1962            exit 1
1963      else      else
1964          echo "    using PDEFAULT=\"$PDEFAULT\""          echo "    using PKG_LIST=\"$PKG_LIST\""
1965          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1966          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          pkg_list=`cat $PKG_LIST | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1967          RETVAL=$?          RETVAL=$?
1968          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1969              printf "Error: can't parse default package list "              printf "Error: can't parse package list "
1970              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PKG_LIST=\"$PKG_LIST\""
1971              exit 1              exit 1
1972          fi          fi
         for i in $def ; do  
             PACKAGES="$PACKAGES $i"  
         done  
         echo "    before group expansion packages are:$PACKAGES"  
         RET=1  
         while test $RET = 1 ; do expand_pkg_groups; RET=$?; done  
         echo "    after group expansion packages are: $PACKAGES"  
1973      fi      fi
1974  fi  fi
1975    for i in $pkg_list ; do
1976        PACKAGES="$PACKAGES $i"
1977    done
1978    echo     "    before group expansion packages are:$PACKAGES"
1979    if test "x${PKG_GROUPS}" != x ; then
1980        RET=1
1981        while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1982        echo "    after group expansion packages are: $PACKAGES"
1983    fi
1984    
1985  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1986  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
# Line 2001  PACKAGES="$PACKAGES $ENABLE" Line 2011  PACKAGES="$PACKAGES $ENABLE"
2011  for i in $PACKAGES ; do  for i in $PACKAGES ; do
2012      j=`echo $i | sed 's/[-+]//'`      j=`echo $i | sed 's/[-+]//'`
2013      if test ! -d "$ROOTDIR/pkg/$j" ; then      if test ! -d "$ROOTDIR/pkg/$j" ; then
2014          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: dir '$ROOTDIR/pkg/$i' missing for package '$i'"
2015          exit 1          exit 1
2016      fi      fi
2017      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
# Line 2020  mnc_in=$? Line 2030  mnc_in=$?
2030  if test "x$HAVE_NETCDF" != xt ; then  if test "x$HAVE_NETCDF" != xt ; then
2031      if test "x$mnc_in" = x0 ; then      if test "x$mnc_in" = x0 ; then
2032          cat <<EOF          cat <<EOF
   
2033  *********************************************************************  *********************************************************************
2034  WARNING: the "mnc" package was enabled but tests failed to compile  WARNING: the "mnc" package was enabled but tests failed to compile
2035    NetCDF applications.  Please check that:    NetCDF applications.  Please check that:
# Line 2031  WARNING: the "mnc" package was enabled b Line 2040  WARNING: the "mnc" package was enabled b
2040    
2041    Due to this failure, the "mnc" package is now DISABLED.    Due to this failure, the "mnc" package is now DISABLED.
2042  *********************************************************************  *********************************************************************
   
2043  EOF  EOF
2044          PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`          PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
2045          DISABLE="$DISABLE mnc"          DISABLE="$DISABLE mnc"
# Line 2063  if test "x$HAVE_NETCDF" != xt ; then Line 2071  if test "x$HAVE_NETCDF" != xt ; then
2071      RETVAL=$?      RETVAL=$?
2072      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
2073          cat <<EOF          cat <<EOF
   
2074  *********************************************************************  *********************************************************************
2075  WARNING: the "profiles" package was enabled but tests failed to  WARNING: the "profiles" package was enabled but tests failed to
2076    compile NetCDF applications.  Please check that:    compile NetCDF applications.  Please check that:
# Line 2074  WARNING: the "profiles" package was enab Line 2081  WARNING: the "profiles" package was enab
2081    
2082    Due to this failure, the "profiles" package is now DISABLED.    Due to this failure, the "profiles" package is now DISABLED.
2083  *********************************************************************  *********************************************************************
   
2084  EOF  EOF
2085          PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`          PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2086          DISABLE="$DISABLE profiles"          DISABLE="$DISABLE profiles"
# Line 2084  EOF Line 2090  EOF
2090      fi      fi
2091  fi  fi
2092    
2093  echo "  applying package dependency rules"  if  test "x${PKG_DEPEND}" != x ; then
2094  ck=    echo "  applying package dependency rules"
2095  while test "x$ck" != xtt ; do    ck=
2096      while test "x$ck" != xtt ; do
2097      i=0      i=0
2098      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2099      rtot=$nname      rtot=$nname
# Line 2157  while test "x$ck" != xtt ; do Line 2164  while test "x$ck" != xtt ; do
2164          #i=$(( $i + 1 ))          #i=$(( $i + 1 ))
2165      done      done
2166      ck=$ck"t"      ck=$ck"t"
2167  done    done
2168  echo "    packages are: $PACKAGES"    echo "    packages are: $PACKAGES"
2169    fi
2170  for i in $PACKAGES ; do  for i in $PACKAGES ; do
2171      adr="$ROOTDIR/pkg/$i"      adr="$ROOTDIR/pkg/$i"
2172      if test -d $adr ; then      if test -d $adr ; then
# Line 2671  output.txt: \$(EXECUTABLE) Line 2679  output.txt: \$(EXECUTABLE)
2679          @printf 'running ... '          @printf 'running ... '
2680          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2681    
2682    # remove most of the files that "make" generates
2683  clean:  clean:
2684          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2685          -rm -rf *.o          -rm -rf *.o
2686          -rm -rf *.$FS *.flowdir          -rm -rf *.$FS *.flowdir
2687          -rm -rf *.f$FS90 \$(AD_CLEAN) ad_input*          -rm -rf *.f$FS90 \$(AD_CLEAN) ad_input*
2688    
2689    # remove most of the files that "make" and "make depend" generate
2690  Clean:  Clean:
2691          @make clean          @make clean
2692          @make cleanlinks          @make cleanlinks
2693          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES) f90mkdepend.log
         -rm -f genmake_state genmake_*optfile genmake_warnings genmake_errors  
         -rm -f make.log run.log f90mkdepend.log *.bak "$MAKEFILE.old"  
2694          -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log          -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2695            -rm -f genmake_warnings genmake_errors make.log
2696    
2697    # remove also the executable, files that "genmake2" generates (except Makefile)
2698    #         and output from a run (plus log files from testreport)
2699  CLEAN:  CLEAN:
2700          @make Clean          @make Clean
2701            -rm -f \$(EXECUTABLE) \$(EXE_AD) *.bak $MAKEFILE.old
2702            -rm -f $LOGFILE genmake_state genmake_*optfile genmake.tr_log make.tr_log
2703          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2704          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2705          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2706          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime          -rm -f *.txt STD* *diagnostics.log datetime
2707          -rm -f *_MIT_CE_000.opt0000 costfunction*0000          -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2708          -rm -rf mnc_test_*          -rm -rf mnc_test_*
2709    
 #eh3 Makefile: makefile  
2710  makefile:  makefile:
2711          $THIS_SCRIPT $G2ARGS          $THIS_SCRIPT $G2ARGS
2712  cleanlinks:  cleanlinks:
# Line 2748  cat >>$MAKEFILE <<EOF Line 2762  cat >>$MAKEFILE <<EOF
2762          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2763  .$FS.o:  .$FS.o:
2764          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2765    .F.o:
2766            \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2767  .F90.$FS90:  .F90.$FS90:
2768          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2769  .FF90.f$FS90:  .FF90.f$FS90:
# Line 2882  ftl_tamc_output.$FS: ftl_input_code.$FS Line 2898  ftl_tamc_output.$FS: ftl_input_code.$FS
2898  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2899          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2900    
   
2901  # ... SVD ...  # ... SVD ...
2902  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2903          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
# Line 3206  if test ! -f AD_CONFIG.h ; then Line 3221  if test ! -f AD_CONFIG.h ; then
3221      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
3222  fi  fi
3223    
   
3224  #  Write the "state" for future records  #  Write the "state" for future records
3225  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" = xt ; then
3226      printf "" > genmake_state      printf "" > genmake_state
3227      for i in $gm_state ; do      for i in $gm_state ; do
3228          t1="t2=\$$i"          t1="t2=\$$i"

Legend:
Removed from v.1.207  
changed lines
  Added in v.1.214

  ViewVC Help
Powered by ViewVC 1.1.22